<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" omit-xml-declaration="yes"/>

<xsl:template match="/window">
	<div id="{name}_window_master" style="width:{width};" class="window" onmousedown="javascript:drag_drop.drag(event,this); javascript:im_window.window_focus(this);" dragdrop="true">
		<b class="corner blackcorner">
			<b class="corner1 blackcorner1"><b></b></b>
			<b class="corner2 blackcorner2"><b></b></b>
			<b class="corner3 blackcorner3"></b>
			<b class="corner4 blackcorner4"></b>
			<b class="corner5 blackcorner5"></b>
		</b>
		<div class="titulo" dragdrop="true">
			<span id="{name}_window_title" style="float:left;" dragdrop="true">
				<xsl:value-of select="title" />
			</span>
			<div id="{name}_window_title_buttons" style="float:right;">
				<div id="{name}_button_minimize" style="display: {pButMin};" class="button_minimize" onclick="javascript:im_window.window_minimize('{name}');"></div>
				<div id="{name}_button_maximize" style="display: {pButMax};" class="button_maximize1" onclick="javascript:im_window.window_maximize('{name}');"></div>
				<div id="{name}_button_close" style="display: {pButClose};" class="button_close" onclick="javascript:im_window.window_close('{name}');"></div>
			</div>
		</div>
		<div id="{name}_window_body" class="body">
			<div id="{name}_window_body_content" class="content" style="overflow:auto;">
				<xsl:copy-of select="content" />
			</div>
		</div>
		<div id="{name}_window_bottom" class="rodape" dragdrop="false"></div>
		<div id="im_sub_menu"></div>
	</div>
</xsl:template>

</xsl:stylesheet>