<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" omit-xml-declaration="yes"/>

<xsl:template match="iq/query">
		<xsl:apply-templates select="." mode="list" />	
</xsl:template>

<xsl:template match="*" mode="list">
   <div id="im_contact_list" style="margin:2px;width:auto;height:200px;overflow-y:auto;">
	   <xsl:for-each select="item">
			<xsl:sort select="group" case-order="upper-first" />
			<xsl:choose>
				<xsl:when test="not(group = preceding-sibling::item/group)">
					<img id="group_{group[current()]}" src="instant_messenger/templates/default/images/group_open.gif" onclick="javascript:im.group_close('{group[current()]}');"/>
					<b><xsl:value-of select="group[current()]" /><br/></b>
					<xsl:apply-templates select="." mode="contacts"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:apply-templates select="." mode="contacts"/>
				</xsl:otherwise>
			</xsl:choose>
	   </xsl:for-each>
	</div>	  
</xsl:template>

<xsl:template match="*" mode="contacts">

	<xsl:choose>
		<xsl:when test="@name">
			<div style="margin-left:15px;cursor:pointer;display:block;" id="{@jid}" idgroup="{group}" idname="{@name}" onmousedown="templates.options(event, '{@jid}');">
				<img id="img_{@jid}" src="instant_messenger/templates/default/images/unavailable.gif" style="margin:0px 2px" />
				<xsl:value-of select="@name"/>
				<br/>
				<span id="status_{@jid}" style="font-size:8pt; font-family:Verdana, Arial, Helvetica, sans-serif; font-style:italic; display:none" />
			</div>
			<span id="sub_{@jid}"></span>							
		</xsl:when>
		<xsl:otherwise>
			<div style="margin-left:15px;cursor:pointer;display:block;" id="{@jid}" idgroup="{group}" idname="" onmousedown="templates.options(event, '{@jid}');">
				<img id="img_{@jid}" src="instant_messenger/templates/default/images/unavailable.gif" style="margin:0px 2px" />
				<xsl:value-of select="@jid"/>
				<br/>
				<span id="status_{@jid}" style="font-size:8pt; font-family:Verdana, Arial, Helvetica, sans-serif; font-style:italic; display:none;" />
			</div>
			<span id="sub_{@jid}"></span>			
		</xsl:otherwise>
	</xsl:choose>
	
</xsl:template>

</xsl:stylesheet>
